import { zodResolver } from '@hookform/resolvers/zod'
import { data } from 'react-router'
import { getValidatedFormData } from 'remix-hook-form'
import { XiorError } from 'xior'

import { getUser } from '~/apis/news/get-user'
import { userRegisterRequest } from '~/apis/news/register-user'
import {
  registerSchema,
  type TRegisterSchema,
} from '~/layouts/news/form-register'
import { generateTokenCookie } from '~/utils/token'

import type { Route } from './+types/actions.register'

export const action = async ({ request }: Route.ActionArgs) => {
  try {
    const {
      errors,
      data: payload,
      receivedValues: defaultValues,
    } = await getValidatedFormData<TRegisterSchema>(
      request,
      zodResolver(registerSchema),
      false,
    )

    if (errors) {
      return data({ success: false, errors, defaultValues }, { status: 400 })
    }

    const { data: registerData } = await userRegisterRequest(payload)
    const { token } = registerData
    const { data: userData } = await getUser({
      accessToken: token,
    })
    const tokenCookie = generateTokenCookie({
      token,
    })

    const headers = new Headers()
    headers.append('Set-Cookie', await tokenCookie)

    return data(
      {
        success: true,
        user: userData,
      },
      {
        headers,
        status: 200,
        statusText: 'OK',
      },
    )
  } catch (error) {
    if (error instanceof XiorError) {
      return data(
        {
          success: false,
          message: error?.response?.data?.error?.message || error.message,
        },
        {
          status: error?.response?.status || 500,
        },
      )
    }
    return data(
      {
        success: false,
        message: 'Internal server error',
      },
      { status: 500 },
    )
  }
}
